routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\MessagesController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\RolesController;
use App\Http\Controllers\TagsController;
use App\Http\Controllers\NotesController;

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('test', function() {

    return \App\Models\User::with('mensajes')->get();
});

Route::get('/', 'App\Http\Controllers\MessagesController@create')->name('mensajes.index');

Route::middleware(['auth'])->group(function () {

    Route::resource('usuarios', UsersController::class);
    Route::put('usuarios-cambiaestado/{id}','App\Http\Controllers\UsersController@cambiaEstado')->name('usuarios.estado');   
    
    Route::resource('mensajes', MessagesController::class);
    Route::get('mensajes/pdf', 'App\Http\Controllers\MessagesController@pdf')->name('mensajes.pdf');   
    
    Route::get('mensajes-exportar', 'App\Http\Controllers\MessagesController@export')->name('mensajes.export');
    Route::get('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');
    Route::post('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');
    
    Route::resource('roles', RolesController::class);
    Route::put('roles-cambiaestado/{id}','App\Http\Controllers\RolesController@cambiaEstado')->name('roles.estado');
    
    Route::resource('tags', TagsController::class);
    Route::resource('notas', NotesController::class);
    
    Route::get('componentes', 'App\Http\Controllers\PagesController@componentes')->name('componentes');
    
});


Route::get('documentacion', 'App\Http\Controllers\PagesController@docu')->name('docu');


//AJAX
Route::get('/get-nueva-nota', 'PrtiController@getClasificacionesCGCombo');

//******************************************************************************* */

Auth::routes();

resources/views/mensajes/edit.blade.php
@extends('adminlte::page')

@section('title', 'Edicion de Mensajes')

@section('content')

<h4 class="alert alert-warning col-12 col-md-12 col-sm-12 col-lg-12"> Edicion de mensaje</h4>

<div class="row mx-1 mt-2">
  <div class="ml-auto">
    <button type="button" class="btn btn-success btn-sm mr-2 mb-2 showModal"
    data-bs-toggle="modal" data-bs-target="#modalAddNote"> <i class="fa fa-plus"></i> Nueva Nota</button>
  </div>
</div>


@if (Session()->has('info'))
<div class="alert alert-success"> {{ Session('info') }}</div>
@endif


<form action="{{ route('mensajes.update',$mensaje->id)}}" method="POST"> 
    {!!method_field('PUT')!!}
    {!! csrf_field() !!}    

     <div class="row">

      <div class="col-12 col-md-4 col-sm-4 col-lg-4">
          <h5 class="alert alert-info">Mensaje 📧</h5>
          <div class="form-group">
            <label class="form-label" for="nombre">Nombre </label>
            <input class="form-control" type="text" name="nombre" id="nombre" value="{{ $mensaje->nombre }}">
            @if ($errors->first('nombre'))
              <span class="alert alert-danger btn btn-sm">{{$errors->first('nombre')}}</span>
            @endif
          </div>
          
          <div class="form-group">
            <label class="form-label" for="email">Email </label>
            <input class="form-control" autocomplete="true" type="email" id="email" name="email" value="{{$mensaje->email }}">
            @if ($errors->first('email'))
              <span class="alert alert-danger btn btn-sm"> {{$errors->first('email') }}</span> 
            @endif                  
          </div>
      
          <div class="form-group">
            <label class="form-label" for="mensaje">Mensaje</label>
            <textarea class="form-control" style="resize:none;"
              name="mensaje" id="mensaje" cols="30" rows="5"> {{ $mensaje->mensaje }}</textarea>
              @if ($errors->first('mensaje'))
              <span class="alert alert-danger btn btn-sm">{{$errors->first('mensaje')}}</span> 
            @endif                          
          </div>
    
      </div>

      <div class="col-12 col-md-4 col-sm-4 col-lg-4">
            <h5 class="alert alert-info">Etiquetas 🏷</h5>
            <div class="row">           
              @foreach ($tags as $tag )                
                  <div class="checkbox mb-10 pb-2 col-12 col-xs-12 col-sm-12 col-md-12 col-lg-12">
                      <input type="checkbox" name="tags[]" id="tags_{{$tag->id}}" {{ $mensaje->tags->pluck('id')->contains($tag->id) ? 'checked' : 'none' }} value="{{$tag->id}}">
                      {{ $tag->name}}
                  </div>
              @endforeach
              @if ($errors->first('tags'))
                  <span class="alert alert-danger btn btn-sm"> {{$errors->first('tags') }}</span> 
              @endif
            </div>
      </div>

      <div class="col-12 col-md-4 col-sm-4 col-lg-4">
         <h5 class="alert alert-info"> Notas 🗒</h5>
          @forelse ($mensaje->notes as $nota)
            <div class="row mt-2 mx-1">
               <textarea name="notes[{{$nota->id}}]" id="nota_{{$nota->id}}" cols="30" rows="5" style="resize:none"> {{ $nota->body }}</textarea>
            </div>
                          
          @empty
              <h5 class="alert alert-warning bold">No hay notas cargadas</h5>
          @endforelse


      </div>

     </div>

     <div class="col-12 col-md-12 col-sm-12 col-lg-12 text-center">

       <button type="submit" class="btn btn-success btn-md">Actualizar</button>

     </div>
      
</form>

@include('notas.create', ['mensaje' => $mensaje])

@endsection

@section('js')

<script type="text/javascript">

    jQuery(document).ready(function () 
    { 

      $('body').on('click', '.showModal', function () {
        $('#modalAddNote').modal('show');
      });
      
      $('body').on('click', '.closeModal', function () {
        $('#frmAddNote')[0].reset();
        $('#modalAddNote').modal('hide');
      });
    
    });
  
</script>

   
@stop

resources/views/mensajes/export.blade.php
@if ($mensajes->count())

    <table>    
        <thead>
            <tr>
                <th>Nombre</th>
                <th>Email</th>
                <th>Mensaje</th>                
            </tr>
        </thead>

        <tbody>       

            @foreach ($mensajes as $m)
                <tr>
                    <td>{{ $m->nombre }}</td>
                    <td>{{ $m->email }}</td>
                    <td>{{ $m->mensaje }}</td>                    
                </tr>
                        
            @endforeach
        
        </tbody>
    </table>

@else
    <table style="width:100%; border:1px solid">
        <tbody>
            <tr> No hay mensajes cargados </tr>
        </tbody>
    </table>

@endif

resources/views/mensajes/index.blade.php
@extends('adminlte::page')

@section('title', 'Mensajes')

@section('content_header')
    <h1 class="text-center alert alert-info">Bienvenido a mensajes 😎✉</h1>
@stop

@section('content')

@if (Session()->has('success'))
    <h3 class="alert alert-success text-center"> {{ Session('success') }}</h3>
@endif

@if (Session()->has('failed'))
    <h3 class="alert alert-danger text-center"> {{ Session('failed') }}</h3>
@endif


    {{-- <div>
        <a href="{{url('mensajes-exportar')}}">Exportar</a> 
        {{-- <a href="{{url('mensajes-importar')}}">Importar</a>   </div>    --}}
    

{{-- <div>
    <form action="{{url('mensajes-importar')}}" method="post" enctype="multipart/form-data" >
        {!! csrf_field() !!}
        <input type="file" name="file">
        <button type="submit">Importar</button>   
    </form>

</div> --}}

<div class="row justify-content-end mb-2">
    <a href="{{route('mensajes.create')}}" class="btn btn-success btn-sm mr-2 mb-2"> <i class="fa fa-plus"></i> Nuevo Mensaje</a>
</div>

{{-- <div class="row float-right mx-1 mt-2">
    <a href="{{route('mensajes.pdf')}}" target="_blank" class="btn btn-danger btn-sm mr-2 mb-2"> <i class="fa fa-file-pdf"></i> PDF</a>
</div> --}}

{{-- {{ dd($mensajes) }} --}}

<div class="card">

    <div class="card-body">

        @if ($mensajes->count())       
        
            <x-adminlte-datatable id="mensajes" :heads="$heads" :config="$config" head-theme="dark" striped hoverable bordered with-buttons>
                @foreach($mensajes as $m)
                    <tr>
                        <td>{{ $m->nombre }}</td>
                        <td>{{ $m->email }}</td>
                        <td>{{ $m->mensaje }}</td>
                        <td>{{ $m->notes->pluck('body')->implode(' - ')}}</td>
                        <td>{{ $m->tags->pluck('name')->implode(', ')}}  </td>
                        <td> 
                            <a href="{{route('mensajes.show',$m->id)}}" title="ver" class="btn btn-info btn-xs"> <i class="fa fa-eye"></i></a>
                            <a href="{{route('mensajes.edit',$m->id)}}" title="editar" class="btn btn-success btn-xs"><i class="fa fa-pen"></i></a>
                            <form action="{{route('mensajes.destroy',$m->id)}}" method="POST" class="d-inline">
                                {!! csrf_field() !!}
                                {!! method_field('DELETE') !!}
                                <button type="submit" class="btn btn-danger btn-xs"><i class="fa fa-times"></i></button>
                            </form>                    
        
                        </td>
                       
                    </tr>
                @endforeach
            </x-adminlte-datatable>
        
        @else
            <table class="table tabke-bordered table-stripped">
                <tbody>
                    <tr> No hay mensajes cargados </tr>
                </tbody>
            </table>
        
        @endif

    </div>    

</div>

@endsection

resources/views/mensajes/index_old.blade.php
@extends('adminlte::page')

@section('title', 'Mensajes')

@section('css')
<link rel="stylesheet" href="https://cdn.datatables.net/responsive/2.5.0/css/responsive.bootstrap5.min.css">

@endsection

@section('content_header')
    <h1 class="text-center alert alert-info">Bienvenido a mensajes 😎✉</h1>
@stop

@section('content')

@if (Session()->has('success'))
    <h3 class="alert alert-success text-center"> {{ Session('success') }}</h3>
@endif

@if (Session()->has('failed'))
    <h3 class="alert alert-danger text-center"> {{ Session('failed') }}</h3>
@endif


    {{-- <div>
        <a href="{{url('mensajes-exportar')}}">Exportar</a> 
        {{-- <a href="{{url('mensajes-importar')}}">Importar</a>   </div>    --}}
    

{{-- <div>
    <form action="{{url('mensajes-importar')}}" method="post" enctype="multipart/form-data" >
        {!! csrf_field() !!}
        <input type="file" name="file">
        <button type="submit">Importar</button>   
    </form>

</div> --}}



{{-- <div class="row float-right mx-1 mt-2">
    <a href="{{route('mensajes.pdf')}}" target="_blank" class="btn btn-danger btn-sm mr-2 mb-2"> <i class="fa fa-file-pdf"></i> PDF</a>
</div> --}}

{{-- {{ dd($mensajes) }} --}}

<div class="row mb-1 mx-3 justify-content-end">
    <a href="{{route('mensajes.create')}}" class="btn btn-success btn-sm mr-2 mb-2"> <i class="fa fa-plus"></i> Nuevo Mensaje</a>
</div> 

<div class="card">   

    <div class="card-body">

        @if ($mensajes->count())      
        
            <table id="mensajes" class="table table-striped table-bordered table-hovered">
    
                    <thead>
                    <tr>
                        <th>Nombre</th>
                        <th>Email</th>
                        <th>Mensaje</th>
                        <th>Notas</th>
                        <th>Etiquetas</th>
                        <th>Acciones</th>
                    </tr>
                    </thead>
    
                @foreach($mensajes as $m)
                    <tr>
                        <td>{{ $m->nombre }}</td>
                        <td>{{ $m->email }}</td>
                        <td>{{ $m->mensaje }}</td>
                        <td>{{ $m->notes->pluck('body')->implode(' - ')}}</td>
                        <td>{{ $m->tags->pluck('name')->implode(', ')}}  </td>
                        <td> 
                            <a href="{{route('mensajes.show',$m->id)}}" title="ver" class="btn btn-info btn-xs"> <i class="fa fa-eye"></i></a>
                            <a href="{{route('mensajes.edit',$m->id)}}" title="editar" class="btn btn-success btn-xs"><i class="fa fa-pen"></i></a>
                            <form action="{{route('mensajes.destroy',$m->id)}}" method="POST" class="d-inline">
                                {!! csrf_field() !!}
                                {!! method_field('DELETE') !!}
                                <button type="submit" class="btn btn-danger btn-xs"><i class="fa fa-times"></i></button>
                            </form>                    
    
                        </td>
                        
                    </tr>
                @endforeach
            </table>
        
        @else
            <table class="table tabke-bordered table-stripped">
                <tbody>
                    <tr> No hay mensajes cargados </tr>
                </tbody>
            </table>
        
        @endif

    </div>


</div>


@endsection

@section('js')

<script src="https://cdn.datatables.net/responsive/2.5.0/js/dataTables.responsive.min.js"> </script>
<script src="https://cdn.datatables.net/responsive/2.5.0/js/responsive.bootstrap5.min.js"></script>

<script>    

jQuery(document).ready(function () 
    { 
        new DataTable('#mensajes', {
            responsive: true,
            autoWidth:false,
            language: {
                url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-AR.json',
            },
           
        });

        
    
    });


</script>



@endsection

resources/views/mensajes/pdf.blade.php
<style type="text/css" scoped>
    @page {          
      margin: 3%;
      margin-top: 50px;      
    }

    body{
      font-family: 'Arial';
      font-size: 12px;
    }

    table tbody tr td, table thead tr th {
      border: 1px solid #000;
      padding: 10px;
    }

    table tbody tr td, table thead tr th {
      font-size: 12px;
    }   

    table{
      width: 100%;
      border-spacing: 0px;
    }      

    .text-center{
      text-align: center;
    }

    section{
      margin-bottom: 25px;
    }

    h1{
      font-size: 24px;
    }
  </style>


@if ($mensajes->count()) 

    <h1 class="text-center"> Mensajes </h1>

    <table>    
        <thead>
            <tr>
                <th>Nombre</th>
                <th>Email</th>
                <th>Mensaje</th>
                <th>Notas</th>
                <th>Etiquetas</th>                                
            </tr>
        </thead>

        <tbody>       

            @foreach ($mensajes as $m)
                <tr>
                    <td>{{ $m->nombre }}</td>
                    <td>{{ $m->email }}</td>
                    <td>{{ $m->mensaje }}</td>
                    <td>{{$m->notes->pluck('body')->implode(', ')}}</td>
                    <td>{{$m->tags->pluck('name')->implode(', ')}}</td>                     
                </tr>
                        
            @endforeach
        
        </tbody>
    </table>

@else
    <table style="width:100%; border:1px solid">
        <tbody>
            <tr> No hay mensajes cargados </tr>
        </tbody>
    </table>

@endif

resources/views/mensajes/show.blade.php
@extends('adminlte::page')

@section('title', 'Ver mensaje')

@section('content')

<div class="card">
    <div class="card-title text-left alert alert-info">
         Ver mensaje ✉
    </div>
       
    <div class="card-body">
       
        <div class="row">

            <div class="col-xs-12 col-sm-12 col-md-12">

                <table class="table table-striped table-hover table-bordered">
                    <tbody>
                        <tr> 
                            <td><strong>Nombre</strong></td>
                            <td> {{ $mensaje->nombre }}</td>
                        </tr>

                        <tr> 
                            <td><strong>Email</strong></td>
                            <td> {{ $mensaje->email }}</td>
                        </tr>

                        <tr> 
                            <td><strong>Cuerpo del mensaje</strong></td>
                            <td> {{ $mensaje->mensaje }}</td>
                        </tr>

                        <tr>
                            <td><strong> Notas</strong></td>
                            <td>{{ $mensaje->notes->pluck('body')->implode(' / ') }}</td>
                        </tr>
                        
                        <tr>
                            <td><strong> Etiquetas</strong></td>
                            <td> {{ $mensaje->tags->pluck('name')->implode(', ') }}</td>
                        </tr>

                    </tbody>
                </table>
               

            </div>

        </div>

    </div>
</div>

@endsection